Package: NBAMSeq
Type: Package
Title: Negative Binomial Additive Model for RNA-Seq Data
Version: 1.28.0
Authors@R: c(
    person("Xu", "Ren", 
        email = "xuren2120@gmail.com", role = c("aut", "cre")),
    person("Pei Fen", "Kuan", 
        email = "peifen.kuan@stonybrook.edu", role = "aut"))
Description: High-throughput sequencing experiments followed by differential 
    expression analysis is a widely used approach to detect genomic biomarkers. 
    A fundamental step in differential expression analysis is to model the 
    association between gene counts and covariates of interest. NBAMSeq a 
    flexible statistical model based on the generalized additive model and 
    allows for information sharing across genes in variance estimation. 
License: GPL-2
URL: https://github.com/reese3928/NBAMSeq
BugReports: https://github.com/reese3928/NBAMSeq/issues
Encoding: UTF-8
Imports: DESeq2, mgcv(>= 1.8-24), BiocParallel, genefilter, methods,
        stats,
Depends: R (>= 3.6), SummarizedExperiment, S4Vectors
Suggests: knitr, rmarkdown, testthat, ggplot2
RoxygenNote: 6.1.0
VignetteBuilder: knitr
biocViews: RNASeq, DifferentialExpression, GeneExpression, Sequencing,
        Coverage
git_url: https://git.bioconductor.org/packages/NBAMSeq
git_branch: RELEASE_3_23
git_last_commit: 7526963
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-28 23:34:35 UTC; biocbuild
Author: Xu Ren [aut, cre],
  Pei Fen Kuan [aut]
Maintainer: Xu Ren <xuren2120@gmail.com>

NBAMSeq
===========

`NBAMSeq` is a Bioconductor package for differential expression analysis based on negative binomial additive model. 

The Bioconductor package can be found [here](https://bioconductor.org/packages/release/bioc/html/NBAMSeq.html).    
The Bioconductor package vignette can be found [here](https://bioconductor.org/packages/release/bioc/vignettes/NBAMSeq/inst/doc/NBAMSeq-vignette.html).   
The `NBAMSeq` paper can be found [here](https://doi.org/10.1186/s12859-020-3506-x).

Package installation
------------
```{r}    
if (!requireNamespace("BiocManager", quietly = TRUE))  install.packages("BiocManager")    
BiocManager::install("NBAMSeq")    
```

Citation
------------
Ren, X., & Kuan, P. F. (2020). Negative binomial additive model for RNA-Seq data analysis. BMC Bioinformatics, 21(1), 1-15.

@article{ren2020negative,    
title={Negative binomial additive model for RNA-Seq data analysis},    
author={Ren, Xu and Kuan, Pei-Fen},    
journal={BMC Bioinformatics},    
volume={21},    
number={1},    
pages={1--15},    
year={2020},    
publisher={BioMed Central}    
}

#' @title Pulling out result
#'
#' @description This function pulls out result from NBAMSeqDataSet object
#' returned by \code{\link{NBAMSeq}}
#' @param object a NBAMSeqDataSet object returned by \code{\link{NBAMSeq}}
#' @param name the name of nonlinear variable or continuous linear variable
#' @param contrast a character of length 3. 1st element: name of factor
#' variable; 2nd element: name of numerator level; 3rd element: name of
#' denominator level. contrast = c("group", "treatment", "control") means
#' comparing treatment vs control for group variable.
#' @param indepfilter either TRUE or FALSE indicating whether independent
#' filtering should be performed. Default is TRUE.
#' @param alpha significant threhold for declaring genes as differentially
#' expressed. Default is 0.1.
#' @param pAdjustMethod pvalue adjustment method. Default is "BH". See
#' \code{\link[stats]{p.adjust}} for details.
#' @param parallel either TRUE or FALSE indicating whether parallel should be
#' used. Default is FALSE.
#' @param BPPARAM an argument provided to \code{\link{bplapply}}. See
#' \code{\link[BiocParallel]{register}} for details.
#' @param ... additional arguments provided to \code{pvalueAdjustment} function
#' in DESeq2. See \code{\link[DESeq2]{results}} for details.
#' @importFrom BiocParallel bplapply bpparam
#' @importFrom stats lowess p.adjust quantile
#' @importFrom genefilter filtered_p
#' @export
#' @return a DataFrame which contains the result
#' @references Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of
#' fold change and dispersion for RNA-seq data with DESeq2. Genome Biology,
#' 15:550. \url{https://doi.org/10.1186/s13059-014-0550-8}
#' @examples
#' gsd = makeExample(n = 3, m = 10)
#' gsd = NBAMSeq(gsd)
#' res = results(gsd, name = "pheno")

results <- function(object, name, contrast, indepfilter = TRUE, alpha = 0.1,
                    pAdjustMethod = "BH", parallel = FALSE,
                    BPPARAM = bpparam(), ...){

    ## check input
    stopifnot(is(object, "NBAMSeqDataSet"))
    ## check whether NBAMSeq has been run before
    if(!metadata(object)$fitted){
        stop("NBAMSeq function should be run before calling results function")
    }

    stopifnot(is.logical(indepfilter))
    stopifnot(length(indepfilter)==1)

    stopifnot(is.numeric(alpha))
    stopifnot(length(alpha)==1)
    stopifnot(alpha>0&alpha<1)

    if(missing(name)&missing(contrast)){
        stop("Either 'name' or 'contrast' argument should be provided.")
    } else if(!missing(name)&!missing(contrast)){
        stop(" 'name' and 'contrast' arguments cannot be both provided.")
    } else if(!missing(name)){
        stopifnot(is.character(name))
        stopifnot(length(name)==1)
        stopifnot(name%in%all.vars(getDesign(object)))

        ## check if name is a factor
        if(is.factor(colData(object)[[name]])){
            stop(" 'name' should be a continuous variable. For factors,
                please use 'contrast' argument.")
        }

        ## check the variable is linear or nonlinear
        flag = grepl(paste0("s\\(",name,"\\)"),
            as.character(getDesign(object))[2])
        if(flag){
            clnm = c("baseMean", paste0(c("edf_", "Chisq_", "PValue_"), name))
            resdf = mcols(object)[clnm]
            names(resdf) = c("baseMean", "edf", "stat", "pvalue")
        }else{
            clnm = c("baseMean", name, paste0(c("SE_", "PValue_"), name))
            resdf = mcols(object)[clnm]
            resdf$stat = resdf[[name]]/resdf[[paste0("SE_",name)]]
            names(resdf) = c("baseMean", "coef", "SE", "pvalue", "stat")
            resdf = resdf[c("baseMean", "coef", "SE", "stat", "pvalue")]
        }
    } else{
        if(!is.character(contrast)|length(contrast)!=3){
            stop(" 'contrast' should be a character of length 3.")
        }
        target = contrast[1]
        firstlevel = contrast[2]
        secondlevel = contrast[3]
        alllevels = levels(colData(object)[[target]])

        if(firstlevel==secondlevel){
            stop("2nd and 3rd element in constrast should be different.")
        }
        if(!target%in%names(colData(object))){
            stop("1st element in contrast should be a variable in colData.")
        }
        if(!is.factor(colData(object)[[target]])){
            stop("The variable in contrast should be a factor. For continuous
                variables, please use 'name' argument.")
        }
        if(!firstlevel%in%alllevels){
            stop("2nd element in contrast should be an appropriate level.")
        }
        if(!secondlevel%in%alllevels){
            stop("3rd element in contrast should be an appropriate level.")
        }

        baselevel = levels(colData(object)[[target]])[1]
        if(firstlevel!=baselevel&secondlevel!=baselevel){
            ## if both first level and second level are not base level,
            ## relevel the factor and refit the model
            dat = data.frame(colData(object))
            dat[,target] = factor(dat[,target],
                levels = c(secondlevel, setdiff(alllevels, secondlevel)))
            formula_offset = update(getDesign(object), y ~ . + offset(logsf))
            temp = paste0("smooth_", all.vars(getDesign(object)))
            smoothcol = temp[temp%in%names(mcols(object))]

            gamFit2 = function(i){
                dat$y = assay(object)[i,]   ## ith gene count
                gamFinalFit = gam(formula_offset,
                    family = negbin(theta = 1/mcols(object)[["dispMAP"]][3],
                        link = "log"), method = "REML",
                    sp = unlist(mcols(object)[smoothcol][i,]), data = dat)
                summary(gamFinalFit)$p.table[paste0(target, firstlevel),]
            }

            if(parallel){
                reslist = bplapply(seq_len(nrow(object)), gamFit2,
                    BPPARAM = BPPARAM)
            } else{
                reslist = lapply(seq_len(nrow(object)), gamFit2)
            }

            resdf = DataFrame(matrix(unlist(reslist), ncol = 4, byrow = TRUE))
            names(resdf) = c("coef", "SE", "stat", "pvalue")
            resdf = cbind(mcols(object)["baseMean"], resdf)
        }else{
            if(secondlevel==baselevel){
                clnm = c("baseMean", paste0(c("", "SE_", "PValue_"),
                    paste0(target,"_", firstlevel,"_vs_",secondlevel)))
            }else{
                clnm = c("baseMean", paste0(c("", "SE_", "PValue_"),
                    paste0(target,"_", secondlevel,"_vs_",firstlevel)))

            }
            resdf = mcols(object)[clnm]
            names(resdf) = c("baseMean", "coef", "SE", "pvalue")
            resdf$stat = resdf[["coef"]]/resdf[["SE"]]
            resdf = resdf[c("baseMean", "coef", "SE", "stat", "pvalue")]
            if(firstlevel==baselevel){
                resdf[["coef"]] = -resdf[["coef"]]
                resdf[["stat"]] = -resdf[["stat"]]
            }
        }
    }

    ## perform independent filtering
    resdf = pvalueAdjustment(resdf, independentFiltering = indepfilter,
        alpha = alpha, pAdjustMethod = pAdjustMethod, ...)
    rownames(resdf) = rownames(assay(object))
    AICBICnms = c("AIC", "BIC", "AICnonlin", "AIClin", "AICintercept", 
                  "BICnonlin", "BIClin", "BICintercept")
    AICBICcolind = which(names(mcols(object))%in%AICBICnms)
    resdf = cbind(resdf, DataFrame(mcols(object)[,AICBICcolind]))
    resdf
}


##############################################################################
# The function pvalueAdjustment is taken from DESeq2 package.
# Author: Michael Love (michaelisaiahlove@gmail.com)
# Reference: Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of
# fold change and dispersion for RNA-seq data with DESeq2. Genome Biology,
# 15:550.
##############################################################################

pvalueAdjustment <- function(res, independentFiltering, filter,
    theta, alpha, pAdjustMethod) {
    # perform independent filtering
    if (independentFiltering) {
        if (missing(filter)) {
            filter <- res$baseMean
        }
        if (missing(theta)) {
            lowerQuantile <- mean(filter == 0)
            if(lowerQuantile < .95) upperQuantile<- .95 else upperQuantile<- 1
            theta <- seq(lowerQuantile, upperQuantile, length=50)
        }
        # do filtering using genefilter
        stopifnot(length(theta) > 1)
        stopifnot(length(filter) == nrow(res))
        filtPadj <- filtered_p(filter=filter, test=res$pvalue,
            theta=theta, method=pAdjustMethod)
        numRej  <- colSums(filtPadj < alpha, na.rm = TRUE)
        # prevent over-aggressive filtering when all genes are null,
        # by requiring the max number of rejections is above a fitted curve.
        # If the max number of rejection is not greater than 10, then don't
        # perform independent filtering at all.
        lo.fit <- lowess(numRej ~ theta, f=1/5)
        if (max(numRej) <= 10) {
            j <- 1
        } else {
            residual <- if (all(numRej==0)) {
                0
            } else {
                numRej[numRej > 0] - lo.fit$y[numRej > 0]
            }
            thresh <- max(lo.fit$y) - sqrt(mean(residual^2))
            j <- if (any(numRej > thresh)) {
                which(numRej > thresh)[1]
            } else {
                1
            }
        }
        # j <- which.max(numRej) # old method
        padj <- filtPadj[, j, drop=TRUE]
        cutoffs <- quantile(filter, theta)
        filterThreshold <- cutoffs[j]
        filterNumRej <- data.frame(theta=theta, numRej=numRej)
        filterTheta <- theta[j]

        metadata(res)[["filterThreshold"]] <- filterThreshold
        metadata(res)[["filterTheta"]] <- filterTheta
        metadata(res)[["filterNumRej"]] <- filterNumRej
        metadata(res)[["lo.fit"]] <- lo.fit
        metadata(res)[["alpha"]] <- alpha
    } else {
        # regular p-value adjustment
        # does not include those rows which were removed
        # by maximum Cook's distance
        padj <- p.adjust(res$pvalue,method=pAdjustMethod)
    }
    res$padj <- padj
    res
}

context("Test NBAMSeq")

test_that("Test invalid input", {

    nrows = 5
    ncols = 10
    counts = matrix(rnbinom(nrows * ncols, 10, 0.3), nrows)
    pheno = runif(ncols, 20, 80)
    colData = DataFrame(pheno = pheno)
    gsd = NBAMSeqDataSet(countData = counts,
        colData = colData, design = ~s(pheno))
    expect_error(NBAMSeq(gsd, gamma = "unknown"))
    expect_error(NBAMSeq(gsd, gamma = -2),
                 " 'gamma' should be greater or equal to 1.")
    expect_error(NBAMSeq(gsd, gamma = c(1,2)))
    expect_error(NBAMSeq(gsd, parallel = 1))
    expect_error(NBAMSeq(gsd, parallel = c(TRUE, FALSE)))
    expect_error(NBAMSeq(gsd, fitlin = 1))
    expect_error(NBAMSeq(gsd, fitlin = c(TRUE, FALSE)))

    #dds = makeExampleDESeqDataSet()
    #expect_error(NBAMSeq(dds))

})


test_that("Test NBAMSeq output", {
    # gsd = makeExample(n=5,m=10)
    ## Test parallel option
    # gsd = NBAMSeq(gsd, parallel = TRUE)
    # gsd2 = NBAMSeq(gsd, parallel = FALSE)
    # expect_identical(gsd,gsd2)
    
    #expect_true("Intercept"%in%names(mcols(gsd)))
    #expect_true("edf_pheno"%in%names(mcols(gsd)))
    #expect_true("Chisq_pheno"%in%names(mcols(gsd)))
    #expect_true("PValue_pheno"%in%names(mcols(gsd)))
    #expect_true("df_residual"%in%names(mcols(gsd)))
    #expect_true("null_deviance"%in%names(mcols(gsd)))
    #expect_true("df_null"%in%names(mcols(gsd)))

    n = 3
    m = 30
    pheno = runif(m, 20, 80)
    mu = matrix(rep(NA, n*m), nrow = n)
    interceptMean = 3
    interceptSD = 2
    betamat = matrix(rep(NA, n*3), nrow = n)
    betamat[,1] = rnorm(n, 3, 2)
    betamat[,2] = 0.2
    betamat[,3] = -0.0025

    x = cbind(rep(1,m), pheno, pheno^2)
    mu = t(2^(x %*% t(betamat))) + 100
    mumean = apply(mu, 1, mean)
    disp = 10/mumean + 0.001

    countData = matrix(rnbinom(m*n, mu=mu, size=1/disp), ncol=m)
    mode(countData) = "integer"
    colnames(countData) = paste0("sample", 1:m)
    rownames(countData) = paste0("gene", 1:n)

    var1 = rnorm(m)
    var2 = rnorm(m)
    var3 = rnorm(m)
    var4 = as.factor(sample(c(0,1,2), m, replace = TRUE))
    colData = data.frame(pheno = pheno, var1 = var1, var2 = var2,
                         var3 = var3, var4 = var4)
    gsd = NBAMSeqDataSet(countData = countData, colData = colData,
                        design = ~ var4 + s(pheno) + s(var1) + var2 + var3)

    ## Test getsf and setsf
    sf = getsf(gsd)
    expect_true(is.null(sf))
    
    sf = sample(1:5,m, replace = TRUE)
    setsf(gsd) = sf
    expect_true(all(getsf(gsd) == sf))
    
    # #### The following code are comments in order to pass the Bioconductor
    # ## check 5 min limit
    # 
    # gsd = NBAMSeqDataSet(countData = countData, colData = colData,
    #                      design = ~ var4 + s(pheno) + s(var1) + var2 + var3)
    # 
    # gsd = NBAMSeq(gsd, parallel = TRUE)
    # gsd2 = NBAMSeq(gsd, parallel = FALSE)
    # expect_identical(gsd,gsd2)
    # expect_true("mu" %in% names(assays(gsd)))
    # expect_true(is.data.frame(assays(gsd)[["mu"]]))
    # expect_true(nrow(assays(gsd)[["mu"]]) == nrow(gsd))
    # expect_true(ncol(assays(gsd)[["mu"]]) == ncol(gsd))
    # expect_true(all(rownames(assays(gsd)[["mu"]]) == rownames(gsd)))
    # expect_true(all(colnames(assays(gsd)[["mu"]]) == colnames(gsd)))
    # 
    # #check if gamma is working well
    # expect_true(all(mcols(gsd)$gamma == 2.5))
    # 
    # sf = getsf(gsd)
    # expect_true(is.numeric(sf))
    # expect_true(length(sf) == m)
    # expect_true(all(names(sf) == paste0("sample", 1:m)))
    # expect_true(all(getsf(gsd) == sf))
    # 
    # dds = DESeqDataSetFromMatrix(countData = assay(gsd),
    #                              colData = colData(gsd), design = ~pheno)
    # dds = estimateSizeFactors(dds)
    # #expect_true(all(sizeFactors(dds)==sf))
    # 
    # 
    # expect_true("Intercept"%in%names(mcols(gsd)))
    # expect_true("edf_var1"%in%names(mcols(gsd)))
    # expect_true("Chisq_var1"%in%names(mcols(gsd)))
    # expect_true("PValue_var1"%in%names(mcols(gsd)))
    # expect_true("var2"%in%names(mcols(gsd)))
    # expect_true("SE_var2"%in%names(mcols(gsd)))
    # expect_true("PValue_var2"%in%names(mcols(gsd)))
    # expect_true("smooth_pheno"%in%names(mcols(gsd)))
    # expect_true("smooth_var1"%in%names(mcols(gsd)))
    # expect_true("df_residual"%in%names(mcols(gsd)))
    # expect_true("null_deviance"%in%names(mcols(gsd)))
    # expect_true("df_null"%in%names(mcols(gsd)))
    # ## check whether AIC/BIC are saved in the object
    # expect_true("AIC"%in%names(mcols(gsd)))
    # expect_true("BIC"%in%names(mcols(gsd)))
    # 
    # # Test invalid input for results function
    # expect_error(results(gsd, name = 1))
    # expect_error(results(gsd, name = c("pheno","var1")))
    # expect_error(results(gsd),
    #              "Either 'name' or 'contrast' argument should be provided.")
    # expect_error(results(gsd, name = "var10"))
    # 
    # expect_error(results(gsd, name = "pheno", indepfilter = "unknown"))
    # expect_error(results(gsd, name = "pheno", indepfilter = c(TRUE, FALSE)))
    # 
    # expect_error(results(gsd, name = "pheno", alpha = "unknown"))
    # expect_error(results(gsd, name = "pheno", alpha = c(0.5, 0.6)))
    # expect_error(results(gsd, name = "pheno", alpha = -0.1))
    # expect_error(results(gsd, name = "pheno", alpha = 1.2))
    # 
    # 
    # ## test result function output
    # expect_error(results(gsd, name = "var4"),
    #              " 'name' should be a continuous variable. For factors,
    #             please use 'contrast' argument.")
    # expect_error(results(gsd, contrast = c("var4", 1)),
    #              " 'contrast' should be a character of length 3.")
    # expect_error(results(gsd, contrast = c("var4", 1, 1)),
    #              "2nd and 3rd element in constrast should be different.")
    # expect_error(results(gsd, contrast = c("var10", 1, 0)),
    #              "1st element in contrast should be a variable in colData.")
    # expect_error(results(gsd, contrast = c("var2", 1, 0)),
    #              "The variable in contrast should be a factor. For continuous
    #             variables, please use 'name' argument.")
    # expect_error(results(gsd, contrast = c("var4", 5, 0)),
    #              "2nd element in contrast should be an appropriate level.")
    # expect_error(results(gsd, contrast = c("var4", 1, 10)),
    #              "3rd element in contrast should be an appropriate level.")
    # 
    # res1 = results(gsd, name = "pheno")
    # expect_true("baseMean"%in%names(res1))
    # expect_true("edf"%in%names(res1))
    # expect_true("stat"%in%names(res1))
    # expect_true("pvalue"%in%names(res1))
    # expect_true("padj"%in%names(res1))
    # expect_true("AIC"%in%names(res1))
    # expect_true("BIC"%in%names(res1))
    # 
    # res2 = results(gsd, name = "var3")
    # expect_true("baseMean"%in%names(res2))
    # expect_true("coef"%in%names(res2))
    # expect_true("SE"%in%names(res2))
    # expect_true("stat"%in%names(res2))
    # expect_true("pvalue"%in%names(res2))
    # expect_true("padj"%in%names(res2))
    # expect_true("AIC"%in%names(res2))
    # expect_true("BIC"%in%names(res2))
    # 
    # ## The following code are comments in order to pass the Bioconductor
    # # ## check 5 min limit
    # ## check contrast
    # res3 = results(gsd, contrast = c("var4", 1, 2), parallel = TRUE)
    # res4 = results(gsd, contrast = c("var4", 2, 1), parallel = TRUE)
    # expect_identical(res3[["baseMean"]], res4[["baseMean"]])
    # expect_equal(res3[["coef"]],-res4[["coef"]], tolerance=1e-8)
    # expect_equal(res3[["SE"]],res4[["SE"]], tolerance=1e-8)
    # expect_equal(res3[["stat"]],-res4[["stat"]], tolerance=1e-8)
    # expect_equal(res3[["pvalue"]],res4[["pvalue"]], tolerance=1e-8)
    # expect_equal(res3[["padj"]],res4[["padj"]], tolerance=1e-8)
    # 
    # # ## check parallel option:
    # res7 = results(gsd, contrast = c("var4", 2, 1), parallel = FALSE)
    # expect_identical(res4[["baseMean"]], res7[["baseMean"]])
    # expect_equal(res4[["coef"]], res7[["coef"]], tolerance=1e-8)
    # expect_equal(res4[["SE"]], res7[["SE"]], tolerance=1e-8)
    # expect_equal(res4[["stat"]], res7[["stat"]], tolerance=1e-8)
    # expect_equal(res4[["pvalue"]], res7[["pvalue"]], tolerance=1e-8)
    # expect_equal(res4[["padj"]], res7[["padj"]], tolerance=1e-8)
    # 
    # 
    # res5 = results(gsd, contrast = c("var4", 1, 0))
    # res6 = results(gsd, contrast = c("var4", 0, 1))
    # expect_identical(res5[["baseMean"]], res6[["baseMean"]])
    # expect_identical(res5[["coef"]], -res6[["coef"]])
    # expect_identical(res5[["SE"]], res6[["SE"]])
    # expect_identical(res5[["stat"]], -res6[["stat"]])
    # expect_equal(res5[["pvalue"]],res6[["pvalue"]], tolerance=1e-8)
    # expect_equal(res5[["padj"]],res6[["padj"]], tolerance=1e-8)
    # 
    # expect_true(all(res5[["coef"]]==mcols(gsd)[["var4_1_vs_0"]]))
    # expect_true(all(res5[["SE"]]==mcols(gsd)[["SE_var4_1_vs_0"]]))
    # expect_true(all(res5[["pvalue"]]==mcols(gsd)[["PValue_var4_1_vs_0"]]))
    # 
    # gsd = NBAMSeqDataSet(countData = countData, colData = colData,
    #                      design = ~ var4 + s(pheno) + s(var1) + var2 + var3)
    # gsd1 = NBAMSeq(gsd, fitlin = TRUE, parallel = TRUE)
    # gsd2 = NBAMSeq(gsd, fitlin = TRUE, parallel = FALSE)
    # expect_identical(gsd1,gsd2)
    # expect_true(!"AIC"%in%names(mcols(gsd1)))
    # expect_true(!"BIC"%in%names(mcols(gsd1)))
    # expect_true("AICnonlin"%in%names(mcols(gsd1)))
    # expect_true("BICnonlin"%in%names(mcols(gsd1)))
    # expect_true("AICintercept"%in%names(mcols(gsd1)))
    # expect_true("BICintercept"%in%names(mcols(gsd1)))
    # expect_true("AIClin"%in%names(mcols(gsd1)))
    # expect_true("BIClin"%in%names(mcols(gsd1)))
    # 
    # res1 = results(gsd1, name = "pheno")
    # expect_true(!"AIC"%in%names(res1))
    # expect_true(!"BIC"%in%names(res1))
    # expect_true("AICnonlin"%in%names(res1))
    # expect_true("BICnonlin"%in%names(res1))
    # expect_true("AICintercept"%in%names(res1))
    # expect_true("BICintercept"%in%names(res1))
    # expect_true("BIClin"%in%names(res1))
    # expect_true("BIClin"%in%names(res1))
})

#' @title Differential expression analysis based on negative binomial additive
#' model
#'
#' @description This function performs differential expression analysis based
#' on negative binomial additive model.
#' @param object a NBAMSeqDataSet object
#' @param gamma a number greater or equal to 1. Increase gamma to create
#' smoother models. Default gamma is 2.5. See \code{\link[mgcv]{gam}} for
#' details.
#' @param parallel either TRUE or FALSE indicating whether parallel should be
#' used. Default is FALSE
#' @param fitlin either TRUE or FALSE indicating whether linear model should be
#' fitted. Default is FALSE
#' @param BPPARAM an argument provided to \code{\link{bplapply}}. See
#' \code{\link[BiocParallel]{register}} for details.
#' @param ... additional arguments provided to \code{\link[mgcv]{gam}}
#' @export
#' @importFrom mgcv gam s nb negbin
#' @import SummarizedExperiment S4Vectors DESeq2
#' @importFrom BiocParallel bplapply bpparam
#' @importFrom methods is new
#' @importFrom stats coef formula update AIC BIC
#' @return a NBAMSeqDataSet object
#' @references Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of
#' fold change and dispersion for RNA-seq data with DESeq2. Genome Biology,
#' 15:550. \url{https://doi.org/10.1186/s13059-014-0550-8}
#' @examples
#' gsd = makeExample(n = 3, m = 10)
#' gsd = NBAMSeq(gsd)

NBAMSeq <- function(object, gamma = 2.5, parallel = FALSE, fitlin = FALSE, 
    BPPARAM = bpparam(), ...){

    ## check input
    stopifnot(is(object, "NBAMSeqDataSet"))
    if(!is.null(gamma)){
        stopifnot(is.numeric(gamma))
        stopifnot(length(gamma)==1)
        if(gamma < 1){
            stop(" 'gamma' should be greater or equal to 1.")
        }
    }
    stopifnot(is.logical(parallel))
    stopifnot(length(parallel)==1)
    stopifnot(is.logical(fitlin))
    stopifnot(length(fitlin)==1)

    ## construct a DESeqDataSet object
    ddsdesign = formula(paste0("~",
        paste(all.vars(getDesign(object)), collapse= "+")) )
    dds = DESeqDataSetFromMatrix(countData = assay(object),
        colData = colData(object), design =  ddsdesign)

    if("sizeFactors"%in%names(colData(dds))){
        logsf = log(colData(object)$sizeFactors)
        object$logsf = logsf    ## save logsf in object
        sizeFactors(dds) = colData(object)$sizeFactors
    }else{
        ## estimate size factors
        dds = estimateSizeFactors(dds)
        logsf = log(sizeFactors(dds))
        colData(object)$sizeFactors = sizeFactors(dds)
        ## save logsf in object
        object$logsf = logsf
    }

    dat = data.frame(colData(object))
    dat$logsf = logsf
    formula_offset = update(getDesign(object), y ~ . + offset(logsf))

    ## gene-wise GAM model
    gamFit1 = function(i){
        dat$y = assay(object)[i,]
        gamfit = tryCatch(
            expr = {
                tmp = gam(formula_offset, family = nb(link = "log"),
                    method = "REML", gamma = gamma, data = dat, ...)
                tmp$gamma = gamma  ## save gamma value in gam object
                tmp
            },
            error = function(e){
                tmp = gam(formula_offset, family = nb(link = "log"),
                    method = "REML", gamma = 1, data = dat, ...)
                tmp$gamma = 1
                tmp
            },
            warning = function(w){
                tmp = gam(formula_offset, family = nb(link = "log"),
                    method = "REML", gamma = 1, data = dat, ...)
                tmp$gamma = 1
                tmp
            }
        )
        list(theta = gamfit$family$getTheta(TRUE), sp = gamfit$sp,
            coef = coef(gamfit), muhat = gamfit$fitted.values,
            outIter = gamfit$outer.info$iter, gamma = gamfit$gamma)
    }

    message("Estimating smoothing parameters and gene-wise dispersions")
    if(parallel){
        gamGeneEst = bplapply(seq_len(nrow(object)),gamFit1,BPPARAM = BPPARAM)
    } else {
        gamGeneEst = lapply(seq_len(nrow(object)), gamFit1)
    }

    ##  get gam gene wise dispersion estimates and save them in mcols(dds)
    mcols(dds)$dispGeneEst = 1/vapply(gamGeneEst, function(x) x$theta, 1)
    ##  bound gene wise dispersion
    maxDisp = pmax(10, ncol(dds))
    mcols(dds)$dispGeneEst = pmin(mcols(dds)$dispGeneEst, maxDisp)

    ##  fit dispersion trend via estimateDispersionsFit function in DESeq2
    message("Estimating dispersion trend")
    dds = estimateDispersionsFit(dds)

    ##  get gam mu estimates and save them in assays(dds)[["mu"]]
    muhat = t(vapply(gamGeneEst, function(x) x$muhat, rep(1, ncol(dds))))
    colnames(muhat) = colnames(dds)
    rownames(muhat) = rownames(dds)
    assays(dds)[["mu"]] = muhat

    ##  MAP dispersion estimates
    message("Estimating MAP dispersion")
    dds = tryCatch(
        expr = {
            estimateDispersionsMAP(dds)
        },
        error = function(e){
            ## avoid possible matrix singular error in DESeq2 C++ code
            assays(dds)[["mu"]] = muhat+1e-6
            estimateDispersionsMAP(dds)
        }
    )
    ind = which(is.na(mcols(dds)$dispMAP))
    if(length(ind)>0){
        mcols(dds)$dispMAP[ind] = mcols(dds)$dispGeneEst[ind]
    }
    
    gamDispMAP = mcols(dds)$dispMAP
    mcols(object) = mcols(dds)

    gamFit2 = function(i){
        dat$y = assay(object)[i,]   ## ith gene count
        start = gamGeneEst[[i]]$coef   ## initial coefficients
        gamFinalFit = gam(formula_offset,
            family = negbin(theta = 1/gamDispMAP[i],link = "log"),
            method = "REML", sp = gamGeneEst[[i]]$sp,
            start = start, data = dat, ...)
        list(mu_hat = gamFinalFit$fitted.values,
            paramcoef = summary(gamFinalFit)$p.table[,"Estimate"],
            paramSE = summary(gamFinalFit)$p.table[,"Std. Error"],
            paramZscore = summary(gamFinalFit)$p.table[,"z value"],
            paramPvalue = summary(gamFinalFit)$p.table[,"Pr(>|z|)"],
            smoothedf = summary(gamFinalFit)$s.table[,"edf"],
            smoothChisq = summary(gamFinalFit)$s.table[,"Chi.sq"],
            smoothPvalue = summary(gamFinalFit)$s.table[,"p-value"],
            deviance = gamFinalFit$deviance,
            innerIter = gamFinalFit$iter,  # number of inner iterations
            converged = gamFinalFit$converged,
            residualdf = gamFinalFit$df.residual,
            nulldeviance = gamFinalFit$null.deviance,
            nulldf = gamFinalFit$df.null,
            AICnonlin = AIC(gamFinalFit),
            BICnonlin = BIC(gamFinalFit)
            )
    }

    message("Estimating model coefficients")
    if(parallel){
        gamFinal = bplapply(seq_len(nrow(object)), gamFit2, BPPARAM = BPPARAM)
    } else{
        gamFinal = lapply(seq_len(nrow(object)), gamFit2)
    }

    ## process variables
    dat$y = assay(object)[1,]
    gammodel = gam(formula_offset, family = negbin(theta = 3, link = "log"),
        method = "REML", data = dat, fit = FALSE)
    ## process factors
    pterms = vapply(attr(gammodel$pterms,"term.labels"),
                    function(x) is.factor(colData(object)[[x]]), FALSE)
    if(length(pterms)==0){
        pterms = "Intercept"
    } else{
        pterms_name = lapply(seq_along(pterms), function(i){
            if(pterms[i]){
                lv = levels(colData(object)[[names(pterms)[i]]])
                rt = paste0(names(pterms)[i],"_", lv[2:length(lv)],"_vs_",lv[1])
            } else{
                rt = names(pterms)[i]
            }
            rt
        })
        pterms = c("Intercept", unlist(pterms_name))
    }

    sterms = setdiff(attr(gammodel$terms,"term.labels"),
        attr(gammodel$pterms,"term.labels"))
    stopifnot(length(sterms)>=1)
    
    ## save fitted values in assays(object)[["mu"]]
    nsamples = ncol(object)
    mu_hat = t(vapply(gamFinal, function(x) x$mu_hat, rep(0, nsamples)))
    mu_hat = data.frame(mu_hat)
    rownames(mu_hat) = rownames(object)
    colnames(mu_hat) = colnames(object)
    assays(object)[["mu"]] = mu_hat

    ## save results in mcols(object)
    n1 = length(gamFinal[[1]]$paramcoef)  ## number of parametric variables
    n2 = length(gamFinal[[1]]$smoothedf)  ## number of nonparametric variables
    nm = names(mcols(object))
    mcols(object) = cbind(mcols(object),
        DataFrame(t(rbind(
            vapply(gamFinal, function(x) x$paramcoef, rep(0, n1)),
            vapply(gamFinal, function(x) x$paramSE, rep(1, n1)),
            vapply(gamFinal, function(x) x$paramPvalue, rep(1, n1)),
            vapply(gamFinal, function(x) x$smoothedf, rep(1, n2)),
            vapply(gamFinal, function(x) x$smoothChisq, rep(1, n2)),
            vapply(gamFinal, function(x) x$smoothPvalue, rep(1, n2)),
            vapply(gamFinal, function(x) x$deviance, 1),
            vapply(gamGeneEst, function(x) x$outIter, 1),
            vapply(gamFinal, function(x) x$innerIter, 1),
            vapply(gamFinal, function(x) x$converged, TRUE),
            vapply(gamGeneEst, function(x) x$sp, rep(1, n2)),
            vapply(gamFinal, function(x) x$residualdf, 0),
            vapply(gamFinal, function(x) x$nulldeviance, 0),
            vapply(gamFinal, function(x) x$nulldf, 0),
            vapply(gamGeneEst, function(x) x$gamma, 1),
            vapply(gamFinal, function(x) x$AICnonlin, 0),
            vapply(gamFinal, function(x) x$BICnonlin, 0)
            ))
            )
        )

    nm = c(nm, pterms, paste0("SE_",pterms), paste0("PValue_", pterms),
        paste0("edf_", sterms), paste0("Chisq_", sterms),
        paste0("PValue_", sterms), "deviance", "outIter", "innerIter",
        "converged", paste0("smooth_", sterms),
        "df_residual", "null_deviance", "df_null", "gamma", "AIC", "BIC")
    colnames(mcols(object)) = nm
    class(mcols(object)[["outIter"]]) = "integer"
    class(mcols(object)[["innerIter"]]) = "integer"
    class(mcols(object)[["converged"]]) = "logical"

    metadata(object)$fitted = TRUE
    
    if(fitlin){
        message("Fitting linear models")
        object = fitlin(object, parallel = parallel, BPPARAM = BPPARAM, ...)
    }
    message("Done!")
    object
}




fitlin = function(object, parallel, BPPARAM, ...){
    AICBICcolind = which(names(mcols(object))%in%c("AIC", "BIC"))
    names(mcols(object))[AICBICcolind] = c("AICnonlin", "BICnonlin")
    
    dat = data.frame(colData(object))
    gamDispMAP = mcols(object)$dispMAP
    
    ## fit intercept only models
    gamFitIntercept = function(i){
        dat$y = assay(object)[i,]   ## ith gene count
        gamFinalFit = gam(y~offset(logsf),
                          family = negbin(theta = 1/gamDispMAP[i],link = "log"),
                          method = "REML", data = dat)
        list(AICintercept = AIC(gamFinalFit), BICintercept = BIC(gamFinalFit))
    }
    if(parallel){
        gamFinalIntercept = bplapply(seq_len(nrow(object)), 
                                     gamFitIntercept, BPPARAM = BPPARAM)
    } else{
        gamFinalIntercept = lapply(seq_len(nrow(object)), gamFitIntercept)
    }
    
    nm = names(mcols(object))
    mcols(object) = cbind(mcols(object),
        DataFrame(t(rbind(
            vapply(gamFinalIntercept, function(x) x$AICintercept, 0),
            vapply(gamFinalIntercept, function(x) x$BICintercept, 0)
        ))
        )
    )
    names(mcols(object)) = c(nm,"AICintercept","BICintercept")
    ## end fitting intercept only models
    
    
    ## fit linear models
    ddsdesign = formula(paste0("~",
        paste(all.vars(getDesign(object)), collapse= "+")) )
    formula_offsetlin = update(ddsdesign, y ~ . + offset(logsf))
    dds = DESeqDataSetFromMatrix(countData = assay(object), 
        colData = colData(object), design = ddsdesign)
    
    ## set size factors to previously estimated size factor
    sizeFactors(dds) = getsf(object)
    
    ## fit gene-wise linear model
    gamFitlin1 = function(i){
        dat$y = assay(object)[i,]
        gamfit = gam(formula_offsetlin, family = nb(link = "log"),
                     method = "REML", data = dat, ...)
        list(theta = gamfit$family$getTheta(TRUE), coef = coef(gamfit), 
             muhat = gamfit$fitted.values)
    }
    if(parallel){
        gamGeneEst = bplapply(seq_len(nrow(object)), 
            gamFitlin1, BPPARAM = BPPARAM)
    } else {
        gamGeneEst = lapply(seq_len(nrow(object)), gamFitlin1)
    }
    
    ##  get gam gene wise dispersion estimates and save them in mcols(dds)
    mcols(dds)$dispGeneEst = 1/vapply(gamGeneEst, function(x) x$theta, 1)
    ##  bound gene wise dispersion
    maxDisp = pmax(10, ncol(dds))
    mcols(dds)$dispGeneEst = pmin(mcols(dds)$dispGeneEst, maxDisp)
    
    ##  fit dispersion trend via estimateDispersionsFit function in DESeq2
    dds = estimateDispersionsFit(dds)
    
    ##  get gam mu estimates and save them in assays(dds)[["mu"]]
    muhat = t(vapply(gamGeneEst, function(x) x$muhat, rep(1, ncol(dds))))
    colnames(muhat) = colnames(dds)
    rownames(muhat) = rownames(dds)
    assays(dds)[["mu"]] = muhat
    
    ##  MAP dispersion estimates
    dds = tryCatch(
        expr = {
            estimateDispersionsMAP(dds)
        },
        error = function(e){
            ## avoid possible matrix singular error in DESeq2 C++ code
            assays(dds)[["mu"]] = muhat+1e-6
            estimateDispersionsMAP(dds)
        }
    )
    ind = which(is.na(mcols(dds)$dispMAP))
    if(length(ind)>0){
        mcols(dds)$dispMAP[ind] = mcols(dds)$dispGeneEst[ind]
    }
    
    gamDispMAP = mcols(dds)$dispMAP
    
    gamFitlin2 = function(i){
        dat$y = assay(object)[i,]   ## ith gene count
        start = gamGeneEst[[i]]$coef   ## initial coefficients
        gamFinalFit = gam(formula_offsetlin,
                          family = negbin(theta = 1/gamDispMAP[i],link = "log"),
                          method = "REML", start = start, data = dat, ...)
        list(AIClin = AIC(gamFinalFit), BIClin = BIC(gamFinalFit))
    }
    
    gamFinallin = bplapply(seq_len(nrow(object)), gamFitlin2, 
                           BPPARAM = bpparam())
    
    nm = names(mcols(object))
    mcols(object) = cbind(mcols(object),
                          DataFrame(t(rbind(
                              vapply(gamFinallin, function(x) x$AIClin, 0),
                              vapply(gamFinallin, function(x) x$BIClin, 0)
                          ))
                          )
    )
    names(mcols(object)) = c(nm,"AIClin","BIClin")
    ## end fitting linear models

    object
}

#' NBAMSeqDataSet class
#'
#' \code{NBAMSeqDataSet} is a class inherited from
#' \code{\link{SummarizedExperiment}}.
#' It is used to store the count matrix, colData, and design formula
#' in differential expression analysis.
#' @slot design a mgcv-type design formula
#' @references Martin Morgan, Valerie Obenchain, Jim Hester and 
#' Hervé Pagès (2018). SummarizedExperiment: SummarizedExperiment container. 
#' R package version 1.12.0.
#' @export NBAMSeqDataSet
setClass("NBAMSeqDataSet",
    contains="SummarizedExperiment",
    representation=representation(
        design = "ANY"
    )
)

setValidity("NBAMSeqDataSet", function(object){
    ##########################################################################
    # The following validity checks are taken from DESeq2 package.
    # Author: Michael Love (michaelisaiahlove@gmail.com)
    # Reference: Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation
    # of fold change and dispersion for RNA-seq data with DESeq2. Genome
    # Biology, 15:550.

    if (! ("counts" %in% assayNames(object)) )
        return( "the assays slot must contain a matrix named 'counts'" )
    if ( !is.numeric( assay(object) ) )
        return( "the count data is not numeric" )
    if ( any( is.na( assay(object) ) ) )
        return( "NA values are not allowed in the count matrix" )
    if ( any( assay(object) < 0 ) )
        return( "the count data contains negative values" )

    design <- getDesign(object)
    stopifnot(is(design, "formula"))

    designVars <- all.vars(design)
    if (!all(designVars %in% names(colData(object)))) {
        return("all variables in design formula must be columns in colData")
    }
    designVarsClass <- vapply(designVars, function(v)
        class(colData(object)[[v]]), "numeric")
    if (any(designVarsClass == "character")) {
        return("variables in design formula are character vectors.
convert these columns of colData(object) to factors before including in the
design formula")
    }
    designFactors <- designVars[designVarsClass == "factor"]
    # levels would duplicate after make.names()
    if (any(vapply(designFactors,function(v) {
        factor.lvls <- levels(colData(object)[[v]])
        factor.nms <- make.names(factor.lvls)
        any(duplicated(factor.nms))
    }, FALSE))) {
        return("levels of factors in the design have non-unique level
names after make.names() is applied. best to only use letters and numbers
for levels of factors in the design")
    }
    # levels contain characters other than letters, numbers, and underscore
    if (any(vapply(designFactors,function(v) {
        factor.lvls <- levels(colData(object)[[v]])
        any(!grepl("^[A-Za-z0-9_.]+$",factor.lvls))
    }, FALSE))) {
        # just a warning for now
        message("Note: levels of factors in the design contain characters
other than letters, numbers, '_' and '.'. It is recommended (but not required)
to use only letters, numbers, and delimiters '_' or '.', as these are safe
characters for column names in R.
[This is a message, not an warning or error]")
    }

    ## end: DESeq2 checks
    ##########################################################################

    ## extra checks for design
    if(!grepl("s\\(", as.character(design)[2])){
        return("At least one variable in design should be nonlinear.
If all variables are linear, use DESeq2 instead.")
    }
    sterms = vapply(designVars, function(x)
        grepl(paste0("s\\(",x,"\\)"), as.character(design)[2]), FALSE)
    if(any(sterms&designVarsClass == "factor")){
        return("Non linear term can not be a factor.")
    }

    ## extra checks for counts
    if(all(assay(object)==0)){
        return("countData can not be all 0.")
    }

    TRUE
})


#' NBAMSeqDataSet constructor
#' @param countData a matrix or data frame contains gene count
#' @param colData a \code{DataFrame} or \code{data.frame}
#' @param design a mgcv type design. e.g. \code{~ s(pheno)} or
#' \code{~ s(pheno) + var1 + var2}
#' @param ... optional arguments passed to \code{SummarizedExperiment}
#' @return a NBAMSeqDataSet object
#' @examples
#' n = 100  ## n stands for number of genes
#' m = 20   ## m stands for sample size
#' countData = matrix(rnbinom(n*m, mu=100, size=1/3), ncol = m)
#' mode(countData) = "integer"
#' colnames(countData) = paste0("sample", 1:m)
#' rownames(countData) = paste0("gene", 1:n)
#' pheno = runif(m, 20, 80)
#' colData = data.frame(pheno = pheno)
#' rownames(colData) = paste0("sample", 1:m)
#' gsd = NBAMSeqDataSet(countData = countData,
#' colData = colData, design = ~s(pheno))
#'
NBAMSeqDataSet <- function(countData, colData, design, ...){

    countData = as.matrix(countData)
    colData = DataFrame(colData)

    ##########################################################################
    # The following validity checks are taken from DESeq2 package.
    # Author: Michael Love (michaelisaiahlove@gmail.com)
    # Reference: Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation
    # of fold change and dispersion for RNA-seq data with DESeq2. Genome
    # Biology, 15:550.

    # check that these agree in number
    stopifnot(ncol(countData) == nrow(colData))
    # check if the rownames of colData are simply in different order
    # than the colnames of the countData, if so throw an error
    # as the user probably should investigate what's wrong
    if (!is.null(rownames(colData)) & !is.null(colnames(countData))) {
        if (all(sort(rownames(colData)) == sort(colnames(countData)))) {
            if (!all(rownames(colData) == colnames(countData))) {
                stop(paste("rownames of the colData:
                    ",paste(rownames(colData),collapse=","),"
                    are not in the same order as the colnames of the countData:
                    ",paste(colnames(countData),collapse=",")))
            }
        }
    }
    if (is.null(rownames(colData)) & !is.null(colnames(countData))) {
        rownames(colData) <- colnames(countData)
    }
    ## end: DESeq2 checks
    ##########################################################################

    se = SummarizedExperiment(assays = list(counts = countData),
        colData = colData, ...)
    object = new("NBAMSeqDataSet", se, design = design)

    if(any(rowSums(assay(object))==0)){
        message(sum(rowSums(assay(object))==0),
" genes have all 0 counts for all samples. Consider filtering out these genes
before differential expression analysis." )
    }
    if(any(assay(object)!=round(assay(object)))){
        message("countData contains non-integers, rounded to the nearest
                integer automatically.")
        assay(object) = round(assay(object))
    }
    metadata(object)$fitted = FALSE
    object
}


#' Accessor functions and replace methods for NBAMSeqDataSet object
#' @name NBAMSeq-methods
#' @rdname NBAMSeq-methods
#' @param theObject a NBAMSeqDataSet object
#' @param value the values to be included in the object
NULL

#' @rdname NBAMSeq-methods
#' @export
setGeneric("getDesign", function(theObject) standardGeneric("getDesign"))

#' For \code{getDesign()}: accessor to the design formula
#' @rdname NBAMSeq-methods
#' @examples
#' ## For getDesign() ##
#' gsd = makeExample()
#' design_gsd = getDesign(gsd)
#' @export
#' @return For \code{getDesign()}: design formula
setMethod("getDesign", "NBAMSeqDataSet", function(theObject) theObject@design)


#' @rdname NBAMSeq-methods
#' @export
setGeneric("getsf", function(theObject) standardGeneric("getsf"))

#' For \code{getsf()}: accessor to the size factors
#' @rdname NBAMSeq-methods
#' @examples
#' ## For getsf() ##
#' gsd = makeExample()
#' sf = getsf(gsd)
#' @references Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of
#' fold change and dispersion for RNA-seq data with DESeq2. Genome Biology,
#' 15:550. \url{https://doi.org/10.1186/s13059-014-0550-8}
#' @return For \code{getsf()}: size factor
#' @export
setMethod("getsf", "NBAMSeqDataSet", function(theObject){
    if (!"sizeFactors" %in% names(colData(theObject)))  return(NULL)
    sf = theObject$sizeFactors
    names(sf) = colnames(theObject)
    sf
})


#' Replace methods for NBAMSeqDataSet object
#' @rdname NBAMSeq-methods
#' @export
setGeneric("setsf<-", function(theObject, value) standardGeneric("setsf<-"))

#' For \code{setsf()}: replace size factors
#' @rdname NBAMSeq-methods
#' @examples
#' ## For setsf() ##
#' n = 100
#' m = 50
#' gsd = makeExample(n = n, m = m)
#' sf = sample(1:5, m, replace = TRUE)
#' setsf(gsd) = sf
#' @return For \code{setsf()}: NBAMSeq object
#' @exportMethod "setsf<-"
setReplaceMethod("setsf", signature = c("NBAMSeqDataSet", "numeric"),
    function(theObject, value){
        stopifnot(is.numeric(value))
        stopifnot(all(!is.na(value)))
        if(length(value)!=ncol(theObject)){
            stop("Size factor length should be the same as number of samples.")
        }
        if(any(value<=0)){
            stop("Size factor cannot be 0 or negative.")
        }
        colData(theObject)$sizeFactors = value
        theObject
})

context("Test validity")

test_that("Test invalid input", {

    n = 10
    m = 30
    counts = matrix(rnbinom(n * m, 10, 0.3), n)

    var1 = rnorm(m)
    var2 = rnorm(m)
    var3 = rnorm(m)
    var4 = as.factor(sample(c(0,1,2), m, replace = TRUE))
    colData = data.frame(var1 = var1, var2 = var2,
                         var3 = var3, var4 = var4)

    counts1 = counts
    counts1[1,1] = "1"
    expect_error(NBAMSeqDataSet(counts1, colData, design = ~ s(var1)))
    counts2 = counts
    counts2[1,1] = NA
    expect_error(NBAMSeqDataSet(counts2, colData, design = ~ s(var1)))
    counts3 = counts
    counts3[1,1] = 3.5
    expect_message(NBAMSeqDataSet(counts3, colData, design = ~ s(var1)),
                   "countData contains non-integers, rounded to the nearest
                integer automatically.")
    counts4 = counts
    counts4[1,1] = -5
    expect_error(NBAMSeqDataSet(counts4, colData, design = ~ s(var1)))

    design1 = matrix(sample(m*4), m, 4)
    expect_error(NBAMSeqDataSet(counts, colData, design = design1))
    expect_error(NBAMSeqDataSet(countData = counts, colData = colData,
        design = ~ var4 + s(var1) + var2 + var3 + var5))

    colData2 = colData
    colData2$var1 = sample(c("normal", "tumor"), m, replace = TRUE)
    expect_error(NBAMSeqDataSet(countData = counts, colData = colData2,
                                design = ~ var4 + var1 + s(var2) + var3))
    expect_error(NBAMSeqDataSet(countData = counts, colData = colData,
        design = ~ var4 + var1 + var2 + var3))
    expect_error(NBAMSeqDataSet(countData = counts, colData = colData,
                                design = ~ s(var4) + var1 + var2 + var3),
                 "Non linear term can not be a factor.")

    counts5 = counts
    counts5[1:2,] = 0
    expect_message(NBAMSeqDataSet(counts5, colData, design = ~ s(var1)),
"2 genes have all 0 counts for all samples. Consider filtering out these genes
before differential expression analysis.")
    counts6 = matrix(0,n,m)
    expect_error(NBAMSeqDataSet(counts6, colData, design = ~ s(var1)))
})

#' @title Make an example NBAMSeqDataSet
#'
#' @description This function makes an example NBAMSeqDataSet
#' @param n number of genes
#' @param m number of samples
#' @importFrom stats rnbinom rnorm runif
#' @export
#' @return a NBAMSeqDataSet object
#' @references Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of
#' fold change and dispersion for RNA-seq data with DESeq2. Genome Biology,
#' 15:550. \url{https://doi.org/10.1186/s13059-014-0550-8}
#' @examples
#' gsd = makeExample()

makeExample <- function(n = 200, m = 30){
    pheno = runif(m, 20, 80)
    mu = matrix(rep(NA, n*m), nrow = n)
    interceptMean = 3
    interceptSD = 2
    betamat = matrix(rep(NA, n*3), nrow = n)
    betamat[,1] = rnorm(n, 3, 2)
    betamat[,2] = 0.2
    betamat[,3] = -0.0025

    x = cbind(rep(1,m), pheno, pheno^2)
    mu = t(2^(x %*% t(betamat))) + 100
    mumean = apply(mu, 1, mean)
    disp = 10/mumean + 0.001

    countData = matrix(rnbinom(m*n, mu=mu, size=1/disp), ncol=m)
    mode(countData) = "integer"
    colnames(countData) = paste0("sample", seq_len(m))
    rownames(countData) = paste0("gene", seq_len(n))

    colData = data.frame(pheno = pheno)
    NBAMSeqDataSet(countData = countData, colData = colData,design = ~ s(pheno))

}

context("Test methods")

test_that("set setsf", {
    n = 5
    m = 10
    gsd = makeExample(n = n, m = m)
    sf = as.factor(sample(1:5,m, replace = TRUE))
    expect_error((setsf(gsd) = sf))
    sf = sample(1:5,m, replace = TRUE)
    sf[5] = NA
    expect_error((setsf(gsd) = sf))
    sf = sample(1:5,m-1, replace = TRUE)
    expect_error((setsf(gsd) = sf),
                 "Size factor length should be the same as number of samples.")
    sf = sample(1:5,m, replace = TRUE)
    sf[5] = -2
    expect_error((setsf(gsd) = sf), "Size factor cannot be 0 or negative.")

})

#' @title Making plots to visualize nonlinear associations
#'
#' @description This function makes plots to visualize nonlinear associations.
#' @param object a NBAMSeqDataSet object
#' @param phenoname the name of nonlinear variable to be visualized
#' @param genename the name of gene to be visualized
#' @param ... additional arguments provided to \code{\link[mgcv]{plot.gam}}
#' @importFrom mgcv gam plot.gam
#' @return the plot made by plot.gam() function
#' @export
#' @examples
#' gsd = makeExample(n = 3, m = 10)
#' gsd = NBAMSeq(gsd)
#' makeplot(gsd, "pheno", "gene3", main = "gene10")


makeplot = function(object, phenoname, genename, ...){
    ## check input
    stopifnot(is(object, "NBAMSeqDataSet"))
    ## check whether NBAMSeq has been run before
    if(!metadata(object)$fitted){
        stop("NBAMSeq function should be run before making plots")
    }
    
    stopifnot(is.character(phenoname))
    stopifnot(length(phenoname)==1)
    stopifnot(phenoname%in%all.vars(getDesign(object)))
    ## check the variable is linear or nonlinear
    flag = grepl(paste0("s\\(",phenoname,"\\)"), 
        as.character(getDesign(object))[2])
    if(!flag){
        stop("Visulization can be made for nonlinear variables only")
    }
    
    stopifnot(is.character(genename))
    stopifnot(length(genename)==1)
    if(!genename%in%rownames(assay(object))){
        stop("genename is not valid")
    }
    ind = which(rownames(assay(object))==genename)
    
    formula_offset = update(getDesign(object), y ~ . + offset(logsf))
    gamDispMAP = mcols(object)$dispMAP
    dat = data.frame(colData(object))
    dat$y = assay(object)[ind,]
    gamfit = gam(formula_offset, family = nb(link = "log"), method = "REML", 
        gamma = mcols(object)[ind,"gamma"], data = dat)
    start = gamfit$coef
    ## get smoothing terms
    sterms = setdiff(attr(gamfit$terms,"term.labels"),
        attr(gamfit$pterms,"term.labels"))
    sps = unlist(mcols(object)[ind, paste0("smooth_",sterms)])
    
    gamFinalFit = gam(formula_offset, 
        family = negbin(theta = 1/gamDispMAP[ind],link = "log"),
        method = "REML", sp = sps, start = start, data = dat)
    
    varind = which(sterms==phenoname)
    plot.gam(gamFinalFit, select = varind, ...)
}

---
title: "NBAMSeq: Negative Binomial Additive Model for RNA-Seq Data"
author: "Xu Ren and Pei Fen Kuan"
date: "`r Sys.Date()`"
output: 
    rmarkdown::html_document:
        highlight: pygments
        toc: true
bibliography: reference.bib
vignette: >
    %\VignetteIndexEntry{Negative Binomial Additive Model for RNA-Seq Data}
    %\VignetteEngine{knitr::rmarkdown}
    %\VignetteEncoding{UTF-8}
---


```{r, echo = FALSE}
knitr::opts_chunk$set(comment = "", message=FALSE, warning = FALSE)
```

## Installation

To install and load NBAMSeq

```{r eval = FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("NBAMSeq")
```

```{r}
library(NBAMSeq)
```

## Introduction

High-throughput sequencing experiments followed by differential expression 
analysis is a widely used approach to detect genomic biomarkers. A fundamental 
step in differential expression analysis is to model the association between 
gene counts and covariates of interest. NBAMSeq is a flexible statistical model 
based on the generalized additive model and allows for information sharing 
across genes in variance estimation. Specifically, we model the logarithm of 
mean gene counts as sums of smooth functions with the smoothing parameters and 
coefficients estimated simultaneously by a nested iteration. The variance is 
estimated by the Bayesian shrinkage approach to fully exploit the information 
across all genes. 

The workflow of NBAMSeq contains three main steps:

* Step 1: Data input using `NBAMSeqDataSet`;

* Step 2: Differential expression (DE) analysis using `NBAMSeq` function;

* Step 3: Pulling out DE results using `results` function. 

Here we illustrate each of these steps respectively.

## Data input

Users are expected to provide three parts of input, i.e. `countData`, 
`colData`, and `design`.

`countData` is a matrix of gene counts generated by RNASeq experiments.

```{r}
## An example of countData
n = 50  ## n stands for number of genes
m = 20   ## m stands for sample size
countData = matrix(rnbinom(n*m, mu=100, size=1/3), ncol = m) + 1
mode(countData) = "integer"
colnames(countData) = paste0("sample", 1:m)
rownames(countData) = paste0("gene", 1:n)
head(countData)
```

`colData` is a data frame which contains the covariates of samples. The sample
order in `colData` should match the sample order in `countData`.

```{r}
## An example of colData
pheno = runif(m, 20, 80)
var1 = rnorm(m)
var2 = rnorm(m)
var3 = rnorm(m)
var4 = as.factor(sample(c(0,1,2), m, replace = TRUE))
colData = data.frame(pheno = pheno, var1 = var1, var2 = var2,
    var3 = var3, var4 = var4)
rownames(colData) = paste0("sample", 1:m)
head(colData)
```

`design` is a formula which specifies how to model the samples. Compared 
with other packages performing DE analysis including 
DESeq2 [@love2014moderated], edgeR [@robinson2010edger], NBPSeq [@di2015nbpseq] 
and BBSeq [@zhou2011powerful], NBAMSeq supports the nonlinear model of 
covariates via mgcv [@wood2015package]. To indicate the nonlinear covariate in 
the model, users are expected to use `s(variable_name)` in the `design` 
formula. In our example, if we would like to model `pheno` as a nonlinear 
covariate, the `design` formula should be: 

```{r}
design = ~ s(pheno) + var1 + var2 + var3 + var4
```

Several notes should be made regarding the `design` formula:

* multiple nonlinear covariates are supported, 
e.g. `design = ~ s(pheno) + s(var1) + var2 + var3 + var4`;

* the nonlinear covariate cannot be a discrete variable, e.g. 
`design = ~ s(pheno) + var1 + var2 + var3 + s(var4)` as `var4` is a factor, 
and it makes no sense to model a factor as nonlinear; 

* at least one nonlinear covariate should be provided in `design`. If all 
covariates are assumed to have linear effect on gene count, use DESeq2 
[@love2014moderated], edgeR [@robinson2010edger], NBPSeq [@di2015nbpseq] or
BBSeq [@zhou2011powerful] instead. e.g. 
`design = ~ pheno + var1 + var2 + var3 + var4` is not supported in NBAMSeq;

* design matrix is not supported. 

We then construct the `NBAMSeqDataSet` using `countData`, `colData`, 
and `design`: 

```{r}
gsd = NBAMSeqDataSet(countData = countData, colData = colData, design = design)
gsd
```

## Differential expression analysis

Differential expression analysis can be performed by `NBAMSeq` function:

```{r}
gsd = NBAMSeq(gsd)
```

Several other arguments in `NBAMSeq` function are available for users to 
customize the analysis.

* `gamma` argument can be used to control the smoothness of the nonlinear 
function. Higher `gamma` means the nonlinear function will be more smooth. 
See the `gamma` argument of 
[gam](https://stat.ethz.ch/R-manual/R-devel/library/mgcv/html/gam.html) 
function in mgcv [@wood2015package] for details. Default `gamma` is 2.5;

* `fitlin` is either `TRUE` or `FALSE` indicating whether linear model should 
be fitted after fitting the nonlinear model;

* `parallel` is either `TRUE` or `FALSE` indicating whether parallel should be
used. e.g. Run `NBAMSeq` with `parallel = TRUE`:

```{r eval=TRUE}
library(BiocParallel)
gsd = NBAMSeq(gsd, parallel = TRUE)
```


## Pulling out DE results

Results of DE analysis can be pulled out by `results` function. For continuous
covariates, the `name` argument should be specified indicating the covariate of
interest. For nonlinear continuous covariates, base mean, effective degrees of 
freedom (edf), test statistics, p-value, and adjusted p-value will be returned.

```{r}
res1 = results(gsd, name = "pheno")
head(res1)
```

For linear continuous covariates, base mean, estimated coefficient, standard 
error, test statistics, p-value, and adjusted p-value will be returned.

```{r}
res2 = results(gsd, name = "var1")
head(res2)
```

For discrete covariates, the `contrast` argument should be specified. e.g. 
`contrast = c("var4", "2", "0")` means comparing level 2 vs. level 0 in `var4`.

```{r}
res3 = results(gsd, contrast = c("var4", "2", "0"))
head(res3)
```

## Visualization

We suggest two approaches to visualize the nonlinear associations. The first 
approach is to plot the smooth components of a fitted negative binomial 
additive model by `plot.gam` function in mgcv [@wood2015package]. This can be
done by calling `makeplot` function and passing in `NBAMSeqDataSet` object. 
Users are expected to provide the phenotype of interest in `phenoname` 
argument and gene of interest in `genename` argument.

```{r}
## assuming we are interested in the nonlinear relationship between gene10's 
## expression and "pheno"
makeplot(gsd, phenoname = "pheno", genename = "gene10", main = "gene10")
```

In addition, to explore the nonlinear association of covariates, it is also 
instructive to look at log normalized counts vs. variable scatter plot. 
Below we show how to produce such plot.

```{r}
## here we explore the most significant nonlinear association
res1 = res1[order(res1$pvalue),]
topgene = rownames(res1)[1]  
sf = getsf(gsd)  ## get the estimated size factors
## divide raw count by size factors to obtain normalized counts
countnorm = t(t(countData)/sf) 
head(res1)
```

```{r}
library(ggplot2)
setTitle = topgene
df = data.frame(pheno = pheno, logcount = log2(countnorm[topgene,]+1))
ggplot(df, aes(x=pheno, y=logcount))+geom_point(shape=19,size=1)+
    geom_smooth(method='loess')+xlab("pheno")+ylab("log(normcount + 1)")+
    annotate("text", x = max(df$pheno)-5, y = max(df$logcount)-1, 
    label = paste0("edf: ", signif(res1[topgene,"edf"],digits = 4)))+
    ggtitle(setTitle)+
    theme(text = element_text(size=10), plot.title = element_text(hjust = 0.5))
```

## Session info

```{r sessionInfo}
sessionInfo()
```


## References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeExample.R
\name{makeExample}
\alias{makeExample}
\title{Make an example NBAMSeqDataSet}
\usage{
makeExample(n = 200, m = 30)
}
\arguments{
\item{n}{number of genes}

\item{m}{number of samples}
}
\value{
a NBAMSeqDataSet object
}
\description{
This function makes an example NBAMSeqDataSet
}
\examples{
gsd = makeExample()
}
\references{
Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of
fold change and dispersion for RNA-seq data with DESeq2. Genome Biology,
15:550. \url{https://doi.org/10.1186/s13059-014-0550-8}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{class}
\name{NBAMSeqDataSet-class}
\alias{NBAMSeqDataSet-class}
\title{NBAMSeqDataSet class}
\description{
\code{NBAMSeqDataSet} is a class inherited from
\code{\link{SummarizedExperiment}}.
It is used to store the count matrix, colData, and design formula
in differential expression analysis.
}
\section{Slots}{

\describe{
\item{\code{design}}{a mgcv-type design formula}
}}

\references{
Martin Morgan, Valerie Obenchain, Jim Hester and 
Hervé Pagès (2018). SummarizedExperiment: SummarizedExperiment container. 
R package version 1.12.0.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/results.R
\name{results}
\alias{results}
\title{Pulling out result}
\usage{
results(object, name, contrast, indepfilter = TRUE, alpha = 0.1,
  pAdjustMethod = "BH", parallel = FALSE, BPPARAM = bpparam(), ...)
}
\arguments{
\item{object}{a NBAMSeqDataSet object returned by \code{\link{NBAMSeq}}}

\item{name}{the name of nonlinear variable or continuous linear variable}

\item{contrast}{a character of length 3. 1st element: name of factor
variable; 2nd element: name of numerator level; 3rd element: name of
denominator level. contrast = c("group", "treatment", "control") means
comparing treatment vs control for group variable.}

\item{indepfilter}{either TRUE or FALSE indicating whether independent
filtering should be performed. Default is TRUE.}

\item{alpha}{significant threhold for declaring genes as differentially
expressed. Default is 0.1.}

\item{pAdjustMethod}{pvalue adjustment method. Default is "BH". See
\code{\link[stats]{p.adjust}} for details.}

\item{parallel}{either TRUE or FALSE indicating whether parallel should be
used. Default is FALSE.}

\item{BPPARAM}{an argument provided to \code{\link{bplapply}}. See
\code{\link[BiocParallel]{register}} for details.}

\item{...}{additional arguments provided to \code{pvalueAdjustment} function
in DESeq2. See \code{\link[DESeq2]{results}} for details.}
}
\value{
a DataFrame which contains the result
}
\description{
This function pulls out result from NBAMSeqDataSet object
returned by \code{\link{NBAMSeq}}
}
\examples{
gsd = makeExample(n = 3, m = 10)
gsd = NBAMSeq(gsd)
res = results(gsd, name = "pheno")
}
\references{
Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of
fold change and dispersion for RNA-seq data with DESeq2. Genome Biology,
15:550. \url{https://doi.org/10.1186/s13059-014-0550-8}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\docType{methods}
\name{NBAMSeq-methods}
\alias{NBAMSeq-methods}
\alias{getDesign}
\alias{getDesign,NBAMSeqDataSet-method}
\alias{getsf}
\alias{getsf,NBAMSeqDataSet-method}
\alias{setsf<-}
\alias{setsf<-,NBAMSeqDataSet,numeric-method}
\title{Accessor functions and replace methods for NBAMSeqDataSet object}
\usage{
getDesign(theObject)

\S4method{getDesign}{NBAMSeqDataSet}(theObject)

getsf(theObject)

\S4method{getsf}{NBAMSeqDataSet}(theObject)

setsf(theObject) <- value

\S4method{setsf}{NBAMSeqDataSet,numeric}(theObject) <- value
}
\arguments{
\item{theObject}{a NBAMSeqDataSet object}

\item{value}{the values to be included in the object}
}
\value{
For \code{getDesign()}: design formula

For \code{getsf()}: size factor

For \code{setsf()}: NBAMSeq object
}
\description{
Accessor functions and replace methods for NBAMSeqDataSet object

For \code{getDesign()}: accessor to the design formula

For \code{getsf()}: accessor to the size factors

Replace methods for NBAMSeqDataSet object

For \code{setsf()}: replace size factors
}
\examples{
## For getDesign() ##
gsd = makeExample()
design_gsd = getDesign(gsd)
## For getsf() ##
gsd = makeExample()
sf = getsf(gsd)
## For setsf() ##
n = 100
m = 50
gsd = makeExample(n = n, m = m)
sf = sample(1:5, m, replace = TRUE)
setsf(gsd) = sf
}
\references{
Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of
fold change and dispersion for RNA-seq data with DESeq2. Genome Biology,
15:550. \url{https://doi.org/10.1186/s13059-014-0550-8}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makeplot.R
\name{makeplot}
\alias{makeplot}
\title{Making plots to visualize nonlinear associations}
\usage{
makeplot(object, phenoname, genename, ...)
}
\arguments{
\item{object}{a NBAMSeqDataSet object}

\item{phenoname}{the name of nonlinear variable to be visualized}

\item{genename}{the name of gene to be visualized}

\item{...}{additional arguments provided to \code{\link[mgcv]{plot.gam}}}
}
\value{
the plot made by plot.gam() function
}
\description{
This function makes plots to visualize nonlinear associations.
}
\examples{
gsd = makeExample(n = 3, m = 10)
gsd = NBAMSeq(gsd)
makeplot(gsd, "pheno", "gene3", main = "gene10")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllClasses.R
\name{NBAMSeqDataSet}
\alias{NBAMSeqDataSet}
\title{NBAMSeqDataSet constructor}
\usage{
NBAMSeqDataSet(countData, colData, design, ...)
}
\arguments{
\item{countData}{a matrix or data frame contains gene count}

\item{colData}{a \code{DataFrame} or \code{data.frame}}

\item{design}{a mgcv type design. e.g. \code{~ s(pheno)} or
\code{~ s(pheno) + var1 + var2}}

\item{...}{optional arguments passed to \code{SummarizedExperiment}}
}
\value{
a NBAMSeqDataSet object
}
\description{
NBAMSeqDataSet constructor
}
\examples{
n = 100  ## n stands for number of genes
m = 20   ## m stands for sample size
countData = matrix(rnbinom(n*m, mu=100, size=1/3), ncol = m)
mode(countData) = "integer"
colnames(countData) = paste0("sample", 1:m)
rownames(countData) = paste0("gene", 1:n)
pheno = runif(m, 20, 80)
colData = data.frame(pheno = pheno)
rownames(colData) = paste0("sample", 1:m)
gsd = NBAMSeqDataSet(countData = countData,
colData = colData, design = ~s(pheno))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/NBAMSeq.R
\name{NBAMSeq}
\alias{NBAMSeq}
\title{Differential expression analysis based on negative binomial additive
model}
\usage{
NBAMSeq(object, gamma = 2.5, parallel = FALSE, fitlin = FALSE,
  BPPARAM = bpparam(), ...)
}
\arguments{
\item{object}{a NBAMSeqDataSet object}

\item{gamma}{a number greater or equal to 1. Increase gamma to create
smoother models. Default gamma is 2.5. See \code{\link[mgcv]{gam}} for
details.}

\item{parallel}{either TRUE or FALSE indicating whether parallel should be
used. Default is FALSE}

\item{fitlin}{either TRUE or FALSE indicating whether linear model should be
fitted. Default is FALSE}

\item{BPPARAM}{an argument provided to \code{\link{bplapply}}. See
\code{\link[BiocParallel]{register}} for details.}

\item{...}{additional arguments provided to \code{\link[mgcv]{gam}}}
}
\value{
a NBAMSeqDataSet object
}
\description{
This function performs differential expression analysis based
on negative binomial additive model.
}
\examples{
gsd = makeExample(n = 3, m = 10)
gsd = NBAMSeq(gsd)
}
\references{
Love, M.I., Huber, W., Anders, S. (2014) Moderated estimation of
fold change and dispersion for RNA-seq data with DESeq2. Genome Biology,
15:550. \url{https://doi.org/10.1186/s13059-014-0550-8}
}
